/**
 * Titel:     Quelltext zu Kapitel 10 <br />
 * Buch:      Grundkurs-Java fr Wirtschaftsinformatiker. Vieweg 2007. <br />
 * Autoren:   Klaus-Georg Deck und Herbert Neuendorf
 * Copyright: Copyright (c) 2007 <br />
 * 
 * @author Herbert Neuendorf<br />
 * @version 1.0 <br />
 * 
 */
class Datum {
	private int tag;     
	private int monat;     
	private int jahr;
	public Datum( int tg, int mo, int ja ) {  
		tag = tg;    
		monat = mo;    
		jahr = ja;
	}
	public String toString() {  // Formatierte String-Darstellung
		String d = tag + "." + monat + "." + jahr;
		return d;
	}
}

class Gehalt {
	private static final double MAXUEBER = 20;
	private static final double MAXFAKTOR = 1.5;
	private static final double MINFAKTOR = 1.0;
	private double stundenLohn;       
	private double grundGehalt;
	private double ueberStdFaktor;    
	private double ueberStunden;
	public Gehalt( double gg, double stl, double f ) { 
		setGrundgehalt( gg );    // Verwendung der kontrollierenden
		setStundenLohn( stl );   // Set-Methoden
		setFaktor( f );
		ueberStunden = 0;
	}
	public void setGrundgehalt( double gg ) {      
		grundGehalt = Math.abs( gg );
	}
	public void setStundenLohn( double stl ) {      
		stundenLohn = Math.abs( stl );
	}
	public void setFaktor( double f ) {
		if( f < MINFAKTOR ) f = MINFAKTOR;   // Kontrolle des
		if( f > MAXFAKTOR ) f = MAXFAKTOR;   // zulssigen Faktors
		ueberStdFaktor = f;
	}
	public void setUeberstunden( double ueber ) {
		if( ueber > MAXUEBER )  ueberStunden = MAXUEBER; 
		else  ueberStunden = ueber;    // Kontrolle berstundenzahl
	}
	public double monatsLohn() { 
		return grundGehalt + ueberStdVerg( ); 
	}
	private double ueberStdVerg() {   // private Hilfsmethode       
		double uSV = stundenLohn * ueberStunden * ueberStdFaktor;
		return uSV;  
	}
}

class Mitarbeiter {
	private String nachName;     
	private String vorName;
	              
	private Datum gebDatum;    // Assoziation mit Klasse Datum       
  	private Gehalt gehalt;     // Assoziation mit Klasse Gehalt 
	      
	public static int anzahl = 0; 
	       
	public static Mitarbeiter mAnlegen() {
		IO.writeln( "Mitarbeiterdaten anlegen:" );
		IO.writeln( "===========================" );
		String n = IO.promptAndReadString( "Nachname: " );
		String v = IO.promptAndReadString( "Vorname: " );
		int tg = IO.promptAndReadInt( "Geburtsdaten - Tag: " );
		int mg = IO.promptAndReadInt( "Geburtsdaten - Monat: " );
		int jg = IO.promptAndReadInt( "Geburtsdaten - Jahr: " );
		Datum gd = new Datum( tg, mg, jg );
		double gg = IO.promptAndReadDouble( "Grundgehalt = " );
		double sl = IO.promptAndReadDouble( "Stundenlohn = " );
		double f = IO.promptAndReadDouble( "berstundenfaktor = " );
		Gehalt g = new Gehalt( gg, sl, f );
		Mitarbeiter m = new Mitarbeiter( n,v,gd,g );
		return m;
	}
	
	public Mitarbeiter(String nn, String vn, Datum gd, Gehalt g) {        
  		nachName = nn;    
		vorName = vn;      
		gebDatum = gd;    
		gehalt = g;        
		anzahl++;    
  	}
	public void ausgabeGehaltsDaten() {
		IO.writeln( "Aktuelle Gehaltsdaten:" );
		IO.writeln( "Name: " + getName() );
		IO.writeln( "Geburtstag: " + gebDatum.toString() );
		IO.writeln( "Monatsgehalt = " + gehalt.monatsLohn() );
	}
	public void setGrundgehalt( double gg ) {       
  		gehalt.setGrundgehalt( gg );   
  	}
	public void setStundenLohn( double stl ) {       
  		gehalt.setStundenLohn( stl );   
  	}
  	public void setUeberStunden( double ueber ) {       
  		gehalt.setUeberstunden( ueber );   
  	}
	private String getName() {    // private Hilfsmethode
	return vorName + " " + nachName ; 
	}
} 

public class Mitarbeiterverwaltung {
	public static void main( String[] args ) {
		Mitarbeiter m1 = Mitarbeiter.mAnlegen();
		do {
			IO.writeln( "Funktionsauswahl:" );
			IO.writeln( "=======================" );
			IO.writeln( "Neuen Mitarbeiter anlegen    = 1" );
			IO.writeln( "Gehaltsdaten ausgeben        = 2" );
			IO.writeln( "Anzahl berstunden eingeben  = 3" );
			IO.writeln( "Gehaltswerte setzen          = 4" );
			int wahl = IO.promptAndReadInt( "Gewnschte Option = " );
			switch( wahl ) {
				case 1:
					m1 = Mitarbeiter.mAnlegen();
					IO.writeln( "Zahl = " + Mitarbeiter.anzahl );
				 	break;
				case 2:
					m1.ausgabeGehaltsDaten();
					break;
				case 3: 
      				m1.setUeberStunden(IO.promptAndReadDouble("berstd. = " ));
					break;
				case 4:
      				m1.setGrundgehalt(IO.promptAndReadDouble("Grundgeh. = "));
      				m1.setStundenLohn(IO.promptAndReadDouble("Stundenl. = "));
					break;
				default:
					IO.writeln( "Keine gltige Option" );	
			}
		}while( IO.promptAndReadChar( "Weiter (j)?" ) == 'j' );  
	}
}













